;===========================================================================================
; Bmp_1.asm  GoAsm assembler
; Charger un bitmap depuis une ressource, le fichier .exe devient autonome
; Programm par AsmGges France
;===========================================================================================
; compile.bat:
; ..\..\bin\GoRC /r, res\bmp_1.rc
; ..\..\bin\GoAsm bmp_1.asm
; ..\..\bin\GoLink bmp_1.obj res\bmp_1.res user32.dll kernel32.dll gdi32.dll
;===========================================================================================

; Inclusion des macros/quates/structures ncessaires au programme
; ----------------------------------------------------------------
  #include "..\..\inc\Windows.inc"
  #include "..\..\inc\all_api.inc"

  IDM_MENU   = 1000
  IDM_EXIT   = 1001

  ID_FRANCE     = 17
  IDB_GOASMSITE = 301

;===========================================================================================
; Dbut du code programme
; -----------------------
.code

start:
    ; Obtenir le handle du programme
    ; ------------------------------
    invoke GetModuleHandle,0
    mov [wc.hInstance],eax

    ; Chargement d'une icne
    ; ----------------------
    invoke LoadIcon,[wc.hInstance],ID_FRANCE
    mov [wc.hIcon],eax

    ; Chargement d'un curseur
    ; -----------------------
    invoke LoadCursor,0,IDC_ARROW
    mov [wc.hCursor],eax

    ; Obtenir la largeur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CXSCREEN
    sub eax,[WinW]
    shr eax,1
    mov [WinX],eax

    ; Obtenir la hauteur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CYSCREEN
    sub eax,[WinH]
    shr eax,1
    mov [WinY],eax

    ; Valider le choix de la structure WNDCLASS
    ; -----------------------------------------
    invoke RegisterClass,addr wc

    ; Cration de la fentre de l'application
    ; ---------------------------------------
    invoke CreateWindowEx,WS_EX_CLIENTEDGE,addr ClassName,addr WindowName,\
                          WS_OVERLAPPEDWINDOW+WS_VISIBLE,\
                          [WinX],[WinY],[WinW],[WinH],0,0,[wc.hInstance],0
    mov [hWnd],eax

    ; Affichage de la fentre
    ; -----------------------
    invoke ShowWindow,[hWnd],SW_SHOWDEFAULT

    ; Rafraichissement de la fentre
    ; ------------------------------
    invoke UpdateWindow,[hWnd]

 ;----------------------------------
 ; Boucle de traitement des messages
 ;----------------------------------
 MessageLoop:
    ; Rceptionne les messages
    ; ------------------------
    invoke GetMessage,addr msg,0,0,0
    or eax,eax
    jz >ExitProgram

    ; Traduit les touches d'entre clavier en messages
    ; ------------------------------------------------
    invoke TranslateMessage,addr msg

    ; Expdition des messages  la procdure Windows
    ; ---------------------------------------------
    invoke DispatchMessage,addr msg

    jmp <MessageLoop

 ExitProgram:
    ; Fermeture de l'application
    ; --------------------------
    invoke ExitProcess,[msg.wParam]

;===========================================================================================
; Procdure principale Windows
;-------------------------------------------------------------------------------------------
WindowProc frame @hwnd, @wmsg, @wparam, @lparam
    uses ebx,esi,edi 

    cmp D[@wmsg],WM_CLOSE
    jne >.wmpaint
        ; Boite  message fin d'application
        ; ---------------------------------
        invoke MessageBox,[@hwnd],addr MsgEnd,addr ClassName,MB_OK+MB_ICONINFORMATION

        ; Demande la fin de l'application
        ; -------------------------------
        invoke PostQuitMessage,0
        jmp >>.exit

    .wmpaint:
    cmp D[@wmsg],WM_PAINT
    jne >>.wmcommand
        invoke BeginPaint,[@hwnd],addr ps

        invoke LoadBitmap,[wc.hInstance],IDB_GOASMSITE
        mov [hBitmap],eax

        invoke CreateCompatibleDC,[ps.hdc]
        mov [hMemDC],eax

        invoke SelectObject,[hMemDC],[hBitmap]

        invoke GetClientRect,[@hwnd],addr rect

        invoke BitBlt,[ps.hdc],0,0,[rect.right],[rect.bottom],[hMemDC],0,0,SRCCOPY

        invoke DeleteDC,[hMemDC]
        invoke DeleteObject,[hBitmap]

        invoke EndPaint,[@hwnd],addr ps
        jmp >.exit

    .wmcommand:
    cmp D[@wmsg],WM_COMMAND
    jne >.defwindowproc
        mov eax,[@wparam]
        cmp ax,IDM_EXIT
        jne >.exit
            invoke MessageBox,[@hwnd],addr MB1Texte,addr ClassName,MB_YESNO

            cmp eax,IDYES
            jne >.exit
                ; Demande la fin de l'application
                ; -------------------------------
                invoke PostQuitMessage,0
                jmp >.exit

    .defwindowproc:
        ; Traitement par dfaut des autres messages Windows
        ; -------------------------------------------------
        invoke DefWindowProc,[@hwnd],[@wmsg],[@wparam],[@lparam]
        ret

    .exit:
    mov eax,0
    ret
endf

;===========================================================================================
; Dfinitions des datas chaines / variables initialises ou non initialises / structures
;-------------------------------------------------------------------------------------------
.data

  WindowName db " Charger un bitmap depuis une ressource",0
  ClassName  db ' AsmGges Win32',0
  MsgEnd     db ' GoAsm AsmGges France @2006  ',0
  MB1Texte   db ' Quitter le programme ?',0
  align 4

  WinX       dd 0
  WinY       dd 0
  WinW       dd 512
  WinH       dd 372

  hWnd       dd ?
  hBitmap    dd ?
  hdc        dd ?
  hMemDC     dd ?

  wc         WNDCLASS    < 0,addr WindowProc,0,0,NULL,NULL,NULL,\
                           2,IDM_MENU,addr ClassName >
  msg        MSG         <>
  ps         PAINTSTRUCT <>
  rect       RECT        <>

;===========================================================================================
